/***********************************************************************
 *
 *      Copyright (C) 2004 Micromuse Ltd.
 *      All Rights Reserved
 *
 *      THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE
 *      The copyright notice above does not evidence any
 *      actual or intended publication of such source code.
 *
 *      RESTRICTED RIGHTS:
 *
 *      This file may have been supplied under a license.
 *      It may be used, disclosed, and/or copied only as permitted
 *      under such license agreement.  Any copy must contain the
 *      above copyright notice and this restricted rights notice.
 *      Use, copying, and/or disclosure of the file is strictly
 *      prohibited unless otherwise provided in the license agreement.
 *
 ***********************************************************************/

/** For some reason, we though that we needed this, but it
	is not really required to	create a message queue...
	var eqs = Components.classes["@mozilla.org/event-queue-service;1"].getService(Components.interfaces.nsIEventQueueService);
	eqs.createMonitoredThreadEventQueue();
*/

var errorCode=0;

try {

	var bDoInstall = false;
	var bDoRemove = false;

	/// Having a package manager is important */
	var gPackageManager ;
	gPackageManager = Components.classes["@micromuse.com/NCIPackageManager;1"].getService(Components.interfaces.nsINCIPackageManager);


	/// Get the Property Manager too
	var propMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);				


	/// Read the command line interface
	var cmdLine = Components.classes["@mozilla.org/appshell/commandLineService;1"].getService(Components.interfaces.nsICmdLineService);
	var text = cmdLine.getCmdLineValue("-install");
	if ( text == null ) {
		text = cmdLine.getCmdLineValue("/install");
		if ( text == null ) {
			text = cmdLine.getCmdLineValue("-remove");
			if ( text == null ) {
				text = cmdLine.getCmdLineValue("/remove");
				if ( text != null ) {
					bDoRemove = true;
				}
			} else {
				bDoRemove = true;
			}
		} else {
			bDoInstall = true;
		}
	} else {
		bDoInstall = true;
	}


	/// Check the options and present help just in case.
	if ( text == null || text == "" || text == 1  ) {
		dump("\nThere is no product to configure.\n");
		dump("\n");
		dump("Usage:");
		dump("   NCISetup -silent -install \"file:///d:/Product.xml\" [-params \"file:///d:/Options.xml\"] [-errorlevel [\"debug\"|\"info\"|\"warning\"|\"error\"]\n");
		dump(" or\n");
		dump("   NCISetup -silent -remove \"file:///d:/Product.xml\" [-errorlevel [\"debug\"|\"info\"|\"warning\"|\"error\"]\n");
		dump("\n");
		quit( 2 );
	} else {
		gPackageManager.productXML = text;
	}


	if ( bDoInstall ) {

		/// Get the error level requisted
		gLog = Components.classes["@micromuse.com/NCILog;1"].getService(Components.interfaces.nsINCILog);
		var errorlevel = cmdLine.getCmdLineValue("-errorlevel");
		if ( errorlevel == "debug" ) {
			gLog.level=3;
		} else if ( errorlevel == "warning" ) {
			gLog.level=1;
		} else if ( errorlevel == "info" ) {
			gLog.level=2;
		} else if ( errorlevel == "error" ) {
			gLog.level=0;
		} else {
			gLog.level=gLog.level;
		}


		/// check if we need to do more...
		params = cmdLine.getCmdLineValue("-params");
		if ( params != "" ) {
			gPackageManager.paramXML = params ;	
		}

		gPackageManager.Initialize();	
		gPackageManager.products.item(0).actionRequest = 1;	// request install

		if ( gPackageManager.products.item(0).actionRequest == 6 ) {
			dump("Error: An updated version of " + gPackageManager.products.item(0).name + " is already installed.\n");
			dump("       Downgrade is not allowed\n\n");
		} else {
			dump( "Installing product: " + gPackageManager.products.item(0).name + ".\n");

			/// Find a way of updating features....
			gPackageManager.PrepareWizard();

			if ( gPackageManager.products.item(0).packages.length == 0 ) {
				dump("Error: The current feature selection does not install any packages. Please check your product description or feature selection.\n");
				errorCode =2;
			} else {
			
			
				var bPreInstallCheck = true;

				/* Check the pre install action */
				for (i=0 ; i < gPackageManager.products.item(0).packages.length ; i++ ) {
					if ( gPackageManager.products.item(0).packages.item(i).actionRequest == 1 || gPackageManager.products.item(0).packages.item(i).actionRequest == 3 || gPackageManager.products.item(0).packages.item(i).actionRequest == 5 ) {
						if (!gPackageManager.products.item(0).packages.item(i).PreInstallCheck() ) {
							dump( "\nPackage" + gPackageManager.products.item(0).packages.item(i).name + ": Precheck failed.\n");
							bPreInstallCheck = false;
						}
					}
				}
				
				if ( bPreInstallCheck ) {
					/// find a way of updating properties....
					propMgr.Commit();
					gPackageManager.products.item(0).Install( null );
					dump( "Product " + gPackageManager.products.item(0).name + " installed OK.\n");
					
				} else {
					dump( "\nProduct " + gPackageManager.products.item(0).name + " not installed: Precheck failed.\n");
					errorCode =2;
				}
			}
		}
	}

	if (bDoRemove) {

		gLog = Components.classes["@micromuse.com/NCILog;1"].getService(Components.interfaces.nsINCILog);
		var errorlevel = cmdLine.getCmdLineValue("-errorlevel");
		if ( errorlevel == "debug" ) {
			gLog.level=3;
		}
		if ( errorlevel == "warning" ) {
			gLog.level=1;
		}
		if ( errorlevel == "info" ) {
			gLog.level=2;
		}
		if ( errorlevel == "error" ) {
			gLog.level=0;
		}
		gPackageManager.Initialize();

		dump( "Removing product: " + gPackageManager.products.item(0).name + ".\n");

		gPackageManager.products.item(0).remove = true;
		gPackageManager.PrepareReadyToRemovePackages();
		gPackageManager.Remove( null );

		dump( "Product " + gPackageManager.products.item(0).name + " removed OK.\n");
	}
	
	if ( errorCode==0 ) {
		var propMgr = Components.classes["@micromuse.com/NCIProperties;1"].getService(Components.interfaces.nsINCIProperties);
		Win32Reb = propMgr.Get( "REBOOT_REQUIRED" );
		if ( Win32Reb == "1" ) {
			dump("A reboot is required to complete this operation.\n");
			errorCode=1;
		}
	}
}

catch ( e ) {
	var pStrBdle= Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);

	var errBundle = pStrBdle.createBundle("chrome://ncisetup/locale/errorCode.properties");
	
	dump("\nError\n");
	var errorText=""
	
	/// Our error code are in the range [2153185280 + error code]
	if ( e.result > 2153185280 ) {
		try {
			errorText = errBundle.GetStringFromName( ( e.result - 2153185280 ));
		}
		catch ( e ) {
			errorText = "Error code: " + e.result + ". Please check ncisetup.log.\n\n" ;
		}
	}
	errorText = errorText + "\nPlease check ncisetup.log.\n" ;
	
	dump( errorText );
	errorCode=2;
}

finally {
	gPackageManager.Finalize();
	gPackageManager = null
}

quit(errorCode);
